package command;

import java.util.LinkedList;

public class Main {
	public static void main(String[] args) {
		TicTacToeBoard board = new TicTacToeBoard();
		
		LinkedList<UndoableCommand<String>> cmds = new LinkedList<>();
		cmds.add(new PlaceXCommand(board, 1, 1));
		cmds.add(new PlaceOCommand(board, 0, 0));
		cmds.add(new PlaceXCommand(board, 0, 1));
		cmds.add(new PlaceOCommand(board, 2, 2));
		cmds.add(new PlaceXCommand(board, 0, 1));
		cmds.add(new PlaceOCommand(board, 1, 2));
		cmds.add(new ClearCommand(board));
		cmds.add(new PlaceOCommand(board, 1, 1));

		board.print();
		System.out.println("Playing!");
		cmds.iterator().forEachRemaining(c -> {
			c.execute();
			board.print();
		});
		System.out.println("Undoing!");
		cmds.descendingIterator().forEachRemaining(c -> {
			c.undo();
			board.print();
		});
	}
}
