package observer;

import java.util.ArrayList;

public class Main {
	public static void main(String[] args) {
		Integer i = Integer.valueOf(0);
		Observable<Integer> obInt = new Observable<Integer>(i);
		
		ArrayList<Observer<Integer>> observers = new ArrayList<>();
		observers.add(new BinaryObserver());
		observers.add(x -> { System.out.println("LOL A LAMBDA: " + x); });
		observers.add(new DecimalObserver());
		observers.add(new HexidecimalObserver());
		observers.forEach(o -> obInt.attach(o));

		System.out.println("Setting value to 3");
		obInt.set(3);
		System.out.println("Setting value to 10");
		obInt.set(10);
		obInt.detach(observers.get(0));
		System.out.println("Setting value to 42");
		obInt.set(42);
		System.out.println("===================");
		Observable<Integer> obInt2 = new Observable<Integer>(1);
		obInt2.attach(observers.get(0));
		obInt2.attach(observers.get(1));
		obInt2.set(1337);
		System.out.println("===================");
		obInt.set(0);
	}
}
