package strategy;

import java.util.Arrays;

public class MergeSortStrategy implements SortStrategy {

	@Override
	public <E extends Comparable<E>> void sort(E[] array) {
		mergesort(array, 0, array.length);
	}
	
	private static <E extends Comparable<E>> void mergesort (E[] array, int lo, int hi) {
		if (hi - lo < 2) {
			return;
		}
		int mid = lo + (hi - lo) / 2;
		mergesort(array, lo, mid);
		mergesort(array, mid, hi);
		merge(array, lo, mid, hi);
	}
	
	private static <E extends Comparable<E>> void merge (E[] array, int lo, int mid, int hi) {
		E[] temp = Arrays.copyOf(array, hi - lo);
		int lo1 = lo;
		int hi1 = mid;
		int lo2 = mid;
		int hi2 = hi;
		int out = 0;
		while (lo1 != hi1 && lo2 != hi2) {
			int comp = array[lo1].compareTo(array[lo2]);
			if (comp <= 0) {
				temp[out++] = array[lo1++];
			} else {
				temp[out++] = array[lo2++];
			}
		}
		// move [lo1, mid] to end
		System.arraycopy(array, lo1, temp, out, hi1 - lo1);
		out += (hi1 - lo1);
		// omitted: moving [lo2, hi] to end (as it would just be copied back)
		System.arraycopy(temp, 0, array, lo, out);
	}

}
